package io.gmss.fiscad.implementations.rfu.metier;

import io.gmss.fiscad.entities.rfu.metier.CaracteristiqueBatiment;
import io.gmss.fiscad.exceptions.BadRequestException;
import io.gmss.fiscad.exceptions.NotFoundException;
import io.gmss.fiscad.interfaces.rfu.metier.CaracteristiqueBatimentService;
import io.gmss.fiscad.repositories.rfu.metier.CaracteristiqueBatimentRepository;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;

@Service
public class CaracteristiqueBatimentServiceImpl implements CaracteristiqueBatimentService {

    private final CaracteristiqueBatimentRepository caracteristiqueBatimentRepository;

    public CaracteristiqueBatimentServiceImpl(CaracteristiqueBatimentRepository caracteristiqueBatimentRepository) {
        this.caracteristiqueBatimentRepository = caracteristiqueBatimentRepository;
    }

    @Override
    public CaracteristiqueBatiment createCaracteristiqueBatiment(CaracteristiqueBatiment caracteristiqueBatiment) throws BadRequestException {
        if (caracteristiqueBatiment.getId() != null) {
            throw new BadRequestException("Impossible de créer une nouvelle caracteristique de batiment ayant un id non null.");
        }
        return caracteristiqueBatimentRepository.save(caracteristiqueBatiment);
    }

    @Override
    public CaracteristiqueBatiment updateCaracteristiqueBatiment(Long id, CaracteristiqueBatiment caracteristiqueBatiment) throws NotFoundException {
        if (caracteristiqueBatiment.getId() == null) {
            throw new BadRequestException("Impossible de mettre à jour une nouvelle caracteristique de batiment ayant un id null.");
        }
        if (!caracteristiqueBatimentRepository.existsById(caracteristiqueBatiment.getId())) {
            throw new NotFoundException("Impossible de trouver la nouvelle caracteristique de batiment spécifié dans notre base de données.");
        }
        return caracteristiqueBatimentRepository.save(caracteristiqueBatiment);
    }

    @Override
    public void deleteCaracteristiqueBatiment(Long id) throws NotFoundException {
        Optional<CaracteristiqueBatiment> caracteristiqueBatimentOptional = caracteristiqueBatimentRepository.findById(id);
        if (caracteristiqueBatimentOptional.isPresent()) {
            caracteristiqueBatimentRepository.deleteById(caracteristiqueBatimentOptional.get().getId());
        } else {
            throw new NotFoundException("Impossible de trouver la nouvelle caracteristique de batiment spécifié dans notre base de données.");
        }
    }

    @Override
    public Page<CaracteristiqueBatiment> getCaracteristiqueBatimentList(Pageable pageable) {
        return caracteristiqueBatimentRepository.findAll(pageable);
    }

    @Override
    public List<CaracteristiqueBatiment> getCaracteristiqueBatimentList() {
        return caracteristiqueBatimentRepository.findAll();
    }


    @Override
    public Optional<CaracteristiqueBatiment> getCaracteristiqueBatimentById(Long id) {
        if (caracteristiqueBatimentRepository.existsById(id)) {
            return caracteristiqueBatimentRepository.findById(id);
        } else {
            throw new NotFoundException("Impossible de trouver la caractéristique spécifiée dans la base de données.");
        }

    }
}
